/**
 * Program POSIXové Fronty
 * @autor František Kučera <franta-hg@frantovo.cz>
 */

#include <program.h>
#include <stdlib.h>
#include <iostream>
#include <readline/readline.h>
#include <signal.h>
#include <strings.h>

#include "fronta.h"

using namespace std;

/**
 * Spuštění programu „POSIXovéFronty“
 */
int main() {

    cout << "Vítejte v programu POSIXovéFronty" << endl;

    /** Nastavíme reakci na signál SIGTERM */
    signal(SIGTERM, zpracujSignal);
    signal(SIGINT, zpracujSignal);

    /** TODO: zeptat se na název fronty */
    //strcpy(nazevFronty, VYCHOZI_NAZEV_FRONTY);
    nazevFronty = "/mojeFronta";

    /** Program pracuje buď v režimu přijímání nebo odesílání */
    if (isOdesilaciRezim()) {
        odesilej();
    } else {
        prijimej();
    }

    fronta.zavriFrontu(false);

    /** Sem se nedostaneme, pokud metody poběží v cyklu – program končí, až když dostane patřičný signál. */
    return (EXIT_SUCCESS);
}

bool isOdesilaciRezim() {

    cout << "Zvolte režim: (p)řijímací / (o)desílací" << endl;

    char odpoved = cin.get();
    cin.get();

    if (odpoved == 'o') {
        return true;
    } else if (odpoved == 'p') {
        return false;
    } else {
        return isOdesilaciRezim();
    }
}

void odesilej() {
    cout << "Odesíláme…" << endl;
    fronta = Fronta(nazevFronty, false, true);

    /** TODO: načíst ze standardního vstupu */
    char zprava[] = "zpráva";

    if (fronta.odesliZpravu(zprava) == 0) {
        cout << "Zpráva odeslána." << endl;
    } else {
        cout << "Při odesílání zprávy došlo k chybě." << endl;
    }
}

void prijimej() {
    cout << "Přijímáme…" << endl;
    fronta = Fronta(nazevFronty, true, false);

    char* zprava = fronta.prijmiZpravu();

    if (zprava == NULL) {
        cout << "Nepodařilo se přijmout zprávu." << endl;
    } else {
        printf("Přijatá zpráva: %s\n", zprava);
    }
}

void zpracujSignal(int signal) {
    if (signal == SIGTERM || signal == SIGINT) {
        cout << "Končím program na základě signálu " << signal << "." << endl;
        exit(1);
    }
}

